# Class VulkanDebugUtilsMessengerCallbackDataEXT

java.lang.Object
com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessengerCallbackDataEXT

All Implemented Interfaces:
  `VulkanDebugUtilsMessengerCallbackDataEXTType`

public final class VulkanDebugUtilsMessengerCallbackDataEXT extends Object implements VulkanDebugUtilsMessengerCallbackDataEXTType
Structure specifying parameters returned to the callback.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanDebugUtilsMessengerCallbackDataEXT.Builder`
  Builds instances of type `VulkanDebugUtilsMessengerCallbackDataEXT`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanDebugUtilsMessengerCallbackDataEXT.Builder`
  `builder()`
  Creates a builder for `VulkanDebugUtilsMessengerCallbackDataEXT`.
  `List<VulkanDebugUtilsLabelEXT>`
  `commandBufferLabels()`
  `static VulkanDebugUtilsMessengerCallbackDataEXT`
  `copyOf(VulkanDebugUtilsMessengerCallbackDataEXTType instance)`
  Creates an immutable copy of a `VulkanDebugUtilsMessengerCallbackDataEXTType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanDebugUtilsMessengerCallbackDataEXT` that have equal attribute values.
  `Set<VulkanDebugUtilsMessengerCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `messageIdName`, `messageIdNumber`, `message`, `queueLabels`, `commandBufferLabels`, `objects`.
  `String`
  `message()`
  `String`
  `messageIdName()`
  `int`
  `messageIdNumber()`
  `List<VulkanDebugUtilsObjectNameInfoEXT>`
  `objects()`
  `List<VulkanDebugUtilsLabelEXT>`
  `queueLabels()`
  `String`
  `toString()`
  Prints the immutable value `VulkanDebugUtilsMessengerCallbackDataEXT` with attribute values.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withCommandBufferLabels(VulkanDebugUtilsLabelEXT... elements)`
  Copy the current immutable object with elements that replace the content of `commandBufferLabels`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withCommandBufferLabels(Iterable<? extends VulkanDebugUtilsLabelEXT> elements)`
  Copy the current immutable object with elements that replace the content of `commandBufferLabels`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withFlags(VulkanDebugUtilsMessengerCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withFlags(Iterable<VulkanDebugUtilsMessengerCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withMessage(String value)`
  Copy the current immutable object by setting a value for the `message` attribute.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withMessageIdName(String value)`
  Copy the current immutable object by setting a value for the `messageIdName` attribute.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withMessageIdNumber(int value)`
  Copy the current immutable object by setting a value for the `messageIdNumber` attribute.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withObjects(VulkanDebugUtilsObjectNameInfoEXT... elements)`
  Copy the current immutable object with elements that replace the content of `objects`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withObjects(Iterable<? extends VulkanDebugUtilsObjectNameInfoEXT> elements)`
  Copy the current immutable object with elements that replace the content of `objects`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withQueueLabels(VulkanDebugUtilsLabelEXT... elements)`
  Copy the current immutable object with elements that replace the content of `queueLabels`.
  `final VulkanDebugUtilsMessengerCallbackDataEXT`
  `withQueueLabels(Iterable<? extends VulkanDebugUtilsLabelEXT> elements)`
  Copy the current immutable object with elements that replace the content of `queueLabels`.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanDebugUtilsMessengerCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The creation flags

  - ### messageIdName

    public String messageIdName()
    Specified by:
      `messageIdName` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The message ID name

  - ### messageIdNumber

    public int messageIdNumber()
    Specified by:
      `messageIdNumber` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The message ID number

  - ### message

    public String message()
    Specified by:
      `message` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The message

  - ### queueLabels

    public List<VulkanDebugUtilsLabelEXT> queueLabels()
    Specified by:
      `queueLabels` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The queue labels

  - ### commandBufferLabels

    public List<VulkanDebugUtilsLabelEXT> commandBufferLabels()
    Specified by:
      `commandBufferLabels` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The command buffer labels

  - ### objects

    public List<VulkanDebugUtilsObjectNameInfoEXT> objects()
    Specified by:
      `objects` in interface `VulkanDebugUtilsMessengerCallbackDataEXTType`
    Returns:
      The object labels

  - ### withFlags

    public final VulkanDebugUtilsMessengerCallbackDataEXT withFlags(VulkanDebugUtilsMessengerCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanDebugUtilsMessengerCallbackDataEXT withFlags(Iterable<VulkanDebugUtilsMessengerCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withMessageIdName

    public final VulkanDebugUtilsMessengerCallbackDataEXT withMessageIdName(String value)
    Copy the current immutable object by setting a value for the `messageIdName` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for messageIdName
    Returns:
      A modified copy or the `this` object

  - ### withMessageIdNumber

    public final VulkanDebugUtilsMessengerCallbackDataEXT withMessageIdNumber(int value)
    Copy the current immutable object by setting a value for the `messageIdNumber` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for messageIdNumber
    Returns:
      A modified copy or the `this` object

  - ### withMessage

    public final VulkanDebugUtilsMessengerCallbackDataEXT withMessage(String value)
    Copy the current immutable object by setting a value for the `message` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for message
    Returns:
      A modified copy or the `this` object

  - ### withQueueLabels

    public final VulkanDebugUtilsMessengerCallbackDataEXT withQueueLabels(VulkanDebugUtilsLabelEXT... elements)
    Copy the current immutable object with elements that replace the content of `queueLabels`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withQueueLabels

    public final VulkanDebugUtilsMessengerCallbackDataEXT withQueueLabels(Iterable<? extends VulkanDebugUtilsLabelEXT> elements)
    Copy the current immutable object with elements that replace the content of `queueLabels`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of queueLabels elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withCommandBufferLabels

    public final VulkanDebugUtilsMessengerCallbackDataEXT withCommandBufferLabels(VulkanDebugUtilsLabelEXT... elements)
    Copy the current immutable object with elements that replace the content of `commandBufferLabels`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withCommandBufferLabels

    public final VulkanDebugUtilsMessengerCallbackDataEXT withCommandBufferLabels(Iterable<? extends VulkanDebugUtilsLabelEXT> elements)
    Copy the current immutable object with elements that replace the content of `commandBufferLabels`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of commandBufferLabels elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withObjects

    public final VulkanDebugUtilsMessengerCallbackDataEXT withObjects(VulkanDebugUtilsObjectNameInfoEXT... elements)
    Copy the current immutable object with elements that replace the content of `objects`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withObjects

    public final VulkanDebugUtilsMessengerCallbackDataEXT withObjects(Iterable<? extends VulkanDebugUtilsObjectNameInfoEXT> elements)
    Copy the current immutable object with elements that replace the content of `objects`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of objects elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanDebugUtilsMessengerCallbackDataEXT` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `messageIdName`, `messageIdNumber`, `message`, `queueLabels`, `commandBufferLabels`, `objects`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanDebugUtilsMessengerCallbackDataEXT` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanDebugUtilsMessengerCallbackDataEXT copyOf(VulkanDebugUtilsMessengerCallbackDataEXTType instance)
    Creates an immutable copy of a `VulkanDebugUtilsMessengerCallbackDataEXTType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanDebugUtilsMessengerCallbackDataEXT instance

  - ### builder

    public static VulkanDebugUtilsMessengerCallbackDataEXT.Builder builder()
    Creates a builder for `VulkanDebugUtilsMessengerCallbackDataEXT`.

        VulkanDebugUtilsMessengerCallbackDataEXT.builder()
           .addFlags|addAllFlags(com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessengerCreateFlag) // flags elements
           .setMessageIdName(String) // required messageIdName
           .setMessageIdNumber(int) // required messageIdNumber
           .setMessage(String) // required message
           .addQueueLabels|addAllQueueLabels(VulkanDebugUtilsLabelEXT) // queueLabels elements
           .addCommandBufferLabels|addAllCommandBufferLabels(VulkanDebugUtilsLabelEXT) // commandBufferLabels elements
           .addObjects|addAllObjects(VulkanDebugUtilsObjectNameInfoEXT) // objects elements
           .build();

    Returns:
      A new VulkanDebugUtilsMessengerCallbackDataEXT builder